package com.hemmis.sudoku;

import java.io.File;
import java.util.Arrays;
import java.util.Collection;

import junit.framework.Assert;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;


@RunWith(Parameterized.class)
public class FieldTest {
	private String fileName;
	
	@Parameters
	public static Collection<Object []> configs() {
		return Arrays.asList(new Object [][] {
				{ "src/test/data/sudoku1.txt" }
				//{ "src/test/data/sudoku2.txt" } //impossible
				,{"src/test/data/sudoku3.txt" }
				,{"src/test/data/sudoku4.txt" }
				,{"src/test/data/sudoku5.txt" }
				//,{"src/test/data/sudoku6.txt" }
				//,{"src/test/data/sudoku7.txt" }
				//,{"src/test/data/sudoku8.txt" }
		});
	}
	
	public FieldTest(String fileName) {
		this.fileName = fileName;
	}
	@Test 
	public void test() throws Exception{
		testFile(fileName);
	}
	
	public void testFile(String fileName) throws Exception {
		System.out.println("Testing File : "+fileName);
		File file = new File(fileName);
		System.out.println("Testing File : "+file.getAbsolutePath());
		Field field = Field.fromFile(file);
		System.out.println(field.toString());
		field.solve();
		System.out.println(field.toString());
		Assert.assertTrue(field.isKnown());
	}
}
